#!/usr/bin/perl
# $Id: crond_checker.sh,v 1.1.1.2.2.2 2007/09/16 01:04 mstauber Exp $
# Copyright 2007-2008 Solarspeed Ltd. All rights reserved.
#
# Description:
#
# Script that runs through a cronjob, tests if all running VPS's have a file called
# /etc/init.d/crond. If they do, it's checked if Crond is running in that VPS. If not,
# then Crond is restarted.
#


system("/usr/sbin/vzlist --no-header --output veid |  awk '{print \$1}' > /tmp/cronve-list");
open(V, "/tmp/cronve-list");
@vpslist = <V>;
close (V);

open(G, "/tmp/cronve-list");
    while ($line = <G>) {
        chomp($line);
        next if $line =~ /^\s*$/;               # skip blank lines
        if ($line =~ /^([0-9]\w*)/) {
		$VPS_ID = $line;
	}

	if ($VPS_ID != 0) {
		if ( -f "/vz/private/$VPS_ID/etc/init.d/crond" ) {
			$report = system("/usr/sbin/vzctl exec $VPS_ID /etc/init.d/crond status > /dev/null");
			if ($report != "0") {
				system("/usr/sbin/vzctl exec $VPS_ID /etc/init.d/crond restart > /dev/null");
			}
		}
        }
    }
close (G);
system("/bin/rm -f /tmp/cronve-list");



